//nec ir remote (Leadtek WinFast)
//atmega32, 16MHz
// 15,625 ,   - 64 

#include "ir_functions.c"

//#define IR_INPUT PIND.2
#define IR_START_MIN    190
#define IR_START_MAX    230
#define IR_PRESSED_MIN  160
#define IR_PRESSED_MAX  190
#define IR_ONE_MIN      28
#define IR_ONE_MAX      42
#define IR_ZERO_MIN     12
#define IR_ZERO_MAX     23


unsigned char stat_rcv = 0;  // : 0 - , 1 -   ,
                                //2 -       (13),     
unsigned char ir_buffer_index = 0;
unsigned long int ir_buffer;
unsigned char ir_timer = 0;



// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
#asm("cli")  
  ir_timer = TCNT0; //  
  TCNT0 = 0x00;  // 
    
  if (stat_rcv == 2)  //  
  {
    if (ir_buffer_index < 32) //    
    {
        if (ir_timer > IR_ONE_MIN && ir_timer < IR_ONE_MAX)  //  
        {         
         ir_buffer |= 1;
        }
        else if (ir_timer > IR_ZERO_MIN && ir_timer < IR_ZERO_MAX)  //  
        {
         ir_buffer |= 0;         
        }
        else  //   ,   
        {
          stat_rcv = 0;
          ir_buffer_index = 0;
        }
        if (ir_buffer_index < 31) ir_buffer <<= 1;
        ir_buffer_index++;
    }
    else  //     
    {
      stat_rcv = 0;
      ir_buffer_index = 0;
      ir_function(ir_buffer);  // 
    }
  }
  
  if (stat_rcv == 1)  // , 13  
  {
    if (ir_timer > IR_START_MIN && ir_timer < IR_START_MAX)  //,   
    {
      stat_rcv = 2;
    }
    else if (ir_timer > IR_PRESSED_MIN && ir_timer < IR_PRESSED_MAX)  //,   
    {
      stat_rcv = 0;
      ir_buffer_index = 0;
      TCCR0=0x00;
      ir_function(ir_buffer);
    }
    else
    {
      stat_rcv = 0;
      ir_buffer_index = 0;
      TCCR0=0x00;
    }
  }
  
  if (stat_rcv == 0)  //  , 
  {
    TCCR0 = 0x05;  // 
    stat_rcv = 1;                    
  }
#asm("sei")
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)  //   ,    
{
 stat_rcv = 0;
 ir_buffer_index = 0;
 TCCR0=0x00;
}


